"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var as_fraction_exports = {};
__export(as_fraction_exports, {
  asFraction: () => asFraction
});
module.exports = __toCommonJS(as_fraction_exports);
var import_close_to = require("./close-to.cjs");
const asFraction = /* @__PURE__ */ __name((num, percentError = 1e-6) => {
  if (isNaN(num)) {
    return [NaN, 1];
  }
  if (num === Infinity) {
    return [Infinity, 1];
  }
  if (num === -Infinity) {
    return [-Infinity, 1];
  }
  if (percentError <= 0 || percentError >= 1) {
    throw new RangeError("percentError should be in the range (0,1)");
  }
  if ((0, import_close_to.closeToZero)(num, percentError)) {
    return [0, 1];
  }
  const sign = num === 0 ? 0 : num < 0 ? -1 : 1;
  const value = sign < 0 ? -num : num;
  const epsilon = value * percentError;
  const intPart = Math.trunc(value);
  const fracPart = value - intPart;
  const floatMin = fracPart - epsilon;
  if (floatMin < 0) {
    return [sign * intPart, 1];
  }
  const floatMax = fracPart + epsilon;
  if (floatMax > 1) {
    return [sign * (1 + intPart), 1];
  }
  let intA = 0;
  let intB = 1;
  let intC = 1;
  let intD = Math.trunc(1 / floatMax);
  let more = true;
  do {
    const intN = Math.trunc((intB * floatMin - intA) / (intC - intD * floatMin));
    if (intN === 0) {
      more = false;
    } else {
      intA += intN * intC;
      intB += intN * intD;
      const intX = Math.trunc((intC - intD * floatMax) / (intB * floatMax - intA));
      if (intX === 0) {
        more = false;
      } else {
        intC += intX * intA;
        intD += intX * intB;
      }
    }
  } while (more);
  const denominator = intB + intD;
  const numerator = sign * (intPart * denominator + (intA + intC));
  return [numerator, denominator];
}, "asFraction");
//# sourceMappingURL=as-fraction.cjs.map
