/**
 * A fraction represented as a tuple of numerator and
 * denominator.
 * The numerator is negative if the value is negative.
 * The denominator is always positive, and at least 1.
 * Both values are integers, though the numerator may
 * be Infinity or NaN as the value requires.
 */
export type FracTuple = [numerator: number, denominator: number];
/**
 * Try to find a human-readable fraction for the given decimal value,
 * within a given percentage error.
 * See {@link https://stackoverflow.com/a/45314258 | the original algorithm by Sjaak}.
 */
export declare const asFraction: (num: number, percentError?: number) => FracTuple;
//# sourceMappingURL=as-fraction.d.ts.map