var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
import { isPlainObject } from "@rickosborne/guard";
import { jsonPathAppend } from "./json-path-append.mjs";
const deepCopy = /* @__PURE__ */ __name((source, options = {}) => {
  const seen = /* @__PURE__ */ new Map();
  const copy = /* @__PURE__ */ __name((value, jsonPath) => {
    if (value == null || typeof value !== "object") {
      return value;
    }
    const existing = seen.get(value);
    if (existing != null) {
      return existing;
    }
    if (Array.isArray(value)) {
      let values = value;
      if (options.onArray != null) {
        const replacement = options.onArray(value, jsonPath);
        if (Array.isArray(replacement)) {
          values = replacement;
        } else {
          return replacement;
        }
      }
      const list = [];
      seen.set(value, list);
      values.forEach((v, n) => {
        list[n] = copy(v, jsonPathAppend(jsonPath, n));
      });
      return list;
    }
    let sourceObj = value;
    const record = {};
    if (!isPlainObject(value)) {
      if (options.onInstance != null) {
        const replacement = options.onInstance(value, jsonPath);
        if (isPlainObject(replacement)) {
          sourceObj = replacement;
        } else {
          return replacement;
        }
      } else {
        seen.set(value, value);
        return value;
      }
    } else if (options.onPlainObject != null) {
      const replacement = options.onPlainObject(value, jsonPath);
      if (isPlainObject(replacement)) {
        sourceObj = replacement;
      } else {
        return replacement;
      }
    }
    seen.set(value, record);
    let keys = Reflect.ownKeys(sourceObj);
    if (options.onKeys != null) {
      keys = options.onKeys(keys, sourceObj, jsonPath) ?? keys;
    }
    keys.forEach((k) => {
      record[k] = copy(sourceObj[k], jsonPathAppend(jsonPath, k));
    });
    return record;
  }, "copy");
  return copy(source, "$");
}, "deepCopy");
export {
  deepCopy
};
//# sourceMappingURL=deep-copy.mjs.map
