"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var deep_sort_exports = {};
__export(deep_sort_exports, {
  deepSort: () => deepSort
});
module.exports = __toCommonJS(deep_sort_exports);
var import_guard = require("@rickosborne/guard");
var import_array_eq = require("./array-eq.cjs");
var import_ecma_key_sort = require("./ecma-key-sort.cjs");
const deepSort = /* @__PURE__ */ __name((obj, options = {}) => {
  const keySorting = options.keySorting ?? "text";
  const keyComparator = typeof keySorting === "function" ? keySorting : keySorting === "ecma" ? (a, b) => (0, import_ecma_key_sort.ecmaKeySort)(String(a), String(b)) : (a, b) => String(a).localeCompare(String(b));
  const sorted = /* @__PURE__ */ new Map();
  const sort = /* @__PURE__ */ __name((o) => {
    if (o == null || typeof o !== "object") {
      return o;
    }
    const seen = sorted.get(o);
    if (seen != null) {
      return seen;
    }
    if (Array.isArray(o)) {
      const a = [];
      sorted.set(o, a);
      o.forEach((item, index) => {
        a[index] = sort(item);
      });
      return a;
    }
    if (!(0, import_guard.isPlainObject)(o)) {
      return o;
    }
    const out = {};
    sorted.set(o, out);
    const originalKeys = Object.keys(o);
    const sortedKeys = originalKeys.slice().sort(keyComparator);
    for (const key of sortedKeys) {
      out[key] = sort(o[key]);
    }
    if ((0, import_array_eq.arrayEq)(originalKeys, sortedKeys)) {
      return out;
    }
    return new Proxy(out, {
      ownKeys() {
        return sortedKeys;
      }
    });
  }, "sort");
  return sort(obj);
}, "deepSort");
//# sourceMappingURL=deep-sort.cjs.map
