var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
import { isPlainObject } from "@rickosborne/guard";
import { arrayEq } from "./array-eq.mjs";
import { ecmaKeySort } from "./ecma-key-sort.mjs";
const deepSort = /* @__PURE__ */ __name((obj, options = {}) => {
  const keySorting = options.keySorting ?? "text";
  const keyComparator = typeof keySorting === "function" ? keySorting : keySorting === "ecma" ? (a, b) => ecmaKeySort(String(a), String(b)) : (a, b) => String(a).localeCompare(String(b));
  const sorted = /* @__PURE__ */ new Map();
  const sort = /* @__PURE__ */ __name((o) => {
    if (o == null || typeof o !== "object") {
      return o;
    }
    const seen = sorted.get(o);
    if (seen != null) {
      return seen;
    }
    if (Array.isArray(o)) {
      const a = [];
      sorted.set(o, a);
      o.forEach((item, index) => {
        a[index] = sort(item);
      });
      return a;
    }
    if (!isPlainObject(o)) {
      return o;
    }
    const out = {};
    sorted.set(o, out);
    const originalKeys = Object.keys(o);
    const sortedKeys = originalKeys.slice().sort(keyComparator);
    for (const key of sortedKeys) {
      out[key] = sort(o[key]);
    }
    if (arrayEq(originalKeys, sortedKeys)) {
      return out;
    }
    return new Proxy(out, {
      ownKeys() {
        return sortedKeys;
      }
    });
  }, "sort");
  return sort(obj);
}, "deepSort");
export {
  deepSort
};
//# sourceMappingURL=deep-sort.mjs.map
