import { type Comparator } from "@rickosborne/typical";
/**
 * Pattern for an array index key, basically any integer.
 */
export declare const INDEX_KEY_PATTERN: RegExp;
/**
 * Try to convert the string-format key into an array index key.
 */
export declare const asIndexKey: (key: string) => number | undefined;
/**
 * Comparator for Object keys in ECMA "correct" order.
 * Don't read the history on this.  It will only depress you.
 * @see {@link https://tc39.es/ecma262/#sec-ordinaryownpropertykeys | OrdinaryOwnPropertyKeys}
 */
export declare const ecmaKeySort: Comparator<string>;
//# sourceMappingURL=ecma-key-sort.d.ts.map