import { DQ, SQ } from "./re-quote.js";
export declare const JSON_PATH_ROOT: "$";
export interface JsonPathAppendOptions {
    /**
     * Provide a preference for quote characters, if needed.
     */
    quotes?: "auto" | typeof DQ | typeof SQ;
}
/**
 * Append the given property key to the given JSON Path expression.
 * This does not attempt to validate anything about the path or the key,
 * only formats it according to very basic rules.  Technically, the
 * spec doesn't handle symbol values, so if you give it a path with
 * a symbol you get an expression which other JSON Path parsers can't
 * handle.  However, it does use the correct function syntax, so it
 * should still at least parse correctly.
 * @see {@link https://datatracker.ietf.org/doc/html/rfc9535 | RFC9535}
 */
export declare const jsonPathAppend: (path: string, key: string | number | symbol, options?: JsonPathAppendOptions) => string;
//# sourceMappingURL=json-path-append.d.ts.map