var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
const _ALinkedList = class _ALinkedList {
  count = 0;
  _head = void 0;
  get head() {
    var _a;
    return (_a = this._head) == null ? void 0 : _a.value;
  }
  get isEmpty() {
    return this.count === 0;
  }
  get length() {
    return this.count;
  }
  around(index) {
    var _a;
    if (index < -1) {
      return [void 0, void 0, void 0];
    }
    if (index === -1) {
      return [void 0, void 0, this._head];
    }
    if (index === 0) {
      return [void 0, this._head, (_a = this._head) == null ? void 0 : _a.next];
    }
    if (index === this.count - 1) {
      return [...this.last2Nodes(), void 0];
    }
    if (index === this.count) {
      return [this.last2Nodes()[1], void 0, void 0];
    }
    if (index > this.count) {
      return [void 0, void 0, void 0];
    }
    let i = 0;
    let current = this._head;
    let prev = void 0;
    while (i < index && current != null) {
      i++;
      prev = current;
      current = current.next;
    }
    return [prev, current, current == null ? void 0 : current.next];
  }
  at(index) {
    var _a;
    return (_a = this.around(index)[1]) == null ? void 0 : _a.value;
  }
  insertAt(index, value) {
    const [prev, next] = this.around(index);
    const node = this.buildNode(prev, value, next);
    this.relink(prev, node, next);
    this.count++;
  }
  pop() {
    if (this.count === 0) {
      return void 0;
    }
    const [penultimate, last] = this.last2Nodes();
    this.relink(penultimate, void 0, void 0);
    this.count--;
    return last == null ? void 0 : last.value;
  }
  push(value) {
    const [, last] = this.last2Nodes();
    const node = this.buildNode(last, value, void 0);
    this.relink(last, node, void 0);
    this.count++;
  }
  shift() {
    if (this._head == null) {
      return void 0;
    }
    const value = this._head.value;
    this.relink(void 0, void 0, this._head.next);
    this.count--;
    return value;
  }
  toArray() {
    return Array.from(this.values());
  }
  unshift(value) {
    const node = this.buildNode(void 0, value, this._head);
    this.relink(void 0, node, this._head);
    this.count++;
  }
  *values() {
    let current = this._head;
    while (current != null) {
      yield current.value;
      current = current.next;
    }
  }
  *valuesAndIndexes() {
    let current = this._head;
    let index = 0;
    while (current != null) {
      yield [current.value, index];
      current = current.next;
      index++;
    }
  }
  walk(decide) {
    this.walkValues(decide);
  }
  walkValues(decide, windows = this.windows()) {
    let adjustedPrev = void 0;
    for (const [prev, current, next, index] of windows) {
      const decision = decide(current.value, index);
      if (decision.deleteItem) {
        this.relink(adjustedPrev ?? prev, void 0, next);
        this.count--;
      }
      if (decision.insertBefore != null) {
        const inserted = this.buildNode(adjustedPrev ?? prev, decision.insertBefore, current);
        this.relink(adjustedPrev ?? prev, inserted, current);
        this.count++;
      }
      if (decision.insertAfter != null) {
        const inserted = this.buildNode(current, decision.insertAfter, next);
        this.relink(current, inserted, next);
        this.count++;
        adjustedPrev = inserted;
      } else {
        adjustedPrev = void 0;
      }
      if (!decision.keepWalking) {
        break;
      }
    }
  }
  *windows() {
    let current = this._head;
    let index = 0;
    let prev = void 0;
    while (current != null) {
      const next = current.next;
      yield [prev, current, next, index];
      prev = current;
      current = next;
      index++;
    }
  }
};
__name(_ALinkedList, "ALinkedList");
let ALinkedList = _ALinkedList;
const _SingleLinkedListImpl = class _SingleLinkedListImpl extends ALinkedList {
  get [Symbol.toStringTag]() {
    return `SingleLinkedList+${this.count}`;
  }
  buildNode(_prev, value, next) {
    return { next, value };
  }
  last2Nodes() {
    let last = this._head;
    if (last == null) {
      return [void 0, void 0];
    }
    let penultimate = void 0;
    while (last.next != null) {
      penultimate = last;
      last = last.next;
    }
    return [penultimate, last];
  }
  relink(prev, node, next) {
    if (prev == null) {
      this._head = node ?? next;
    } else {
      prev.next = node ?? next;
    }
  }
};
__name(_SingleLinkedListImpl, "SingleLinkedListImpl");
let SingleLinkedListImpl = _SingleLinkedListImpl;
const singleLinkedList = /* @__PURE__ */ __name(() => {
  return new SingleLinkedListImpl();
}, "singleLinkedList");
const _DoubleLinkedListImpl = class _DoubleLinkedListImpl extends SingleLinkedListImpl {
  _tail = void 0;
  get tail() {
    var _a;
    return (_a = this._tail) == null ? void 0 : _a.value;
  }
  get [Symbol.toStringTag]() {
    return `DoubleLinkedList+${this.count}`;
  }
  around(index) {
    const reverseIndex = this.reverseIndex(index);
    if (reverseIndex >= index) {
      return super.around(index);
    }
    let i = 0;
    let current = this._tail;
    while (i < reverseIndex && current != null) {
      i++;
      current = current.prev;
    }
    return [current == null ? void 0 : current.prev, current, current == null ? void 0 : current.next];
  }
  buildNode(prev, value, next) {
    return { next, prev, value };
  }
  last2Nodes() {
    var _a;
    return [(_a = this._tail) == null ? void 0 : _a.prev, this._tail];
  }
  relink(prev, node, next) {
    super.relink(prev, node, next);
    if (next == null) {
      this._tail = node ?? prev;
    } else {
      next.prev = node ?? prev;
    }
  }
  reverseIndex(index) {
    return this.count - index - 1;
  }
  *reverseValues() {
    let current = this._tail;
    while (current != null) {
      yield current.value;
      current = current.prev;
    }
  }
  *reverseValuesAndIndexes() {
    let current = this._tail;
    let index = this.count - 1;
    while (current != null) {
      yield [current.value, index];
      current = current.prev;
      index--;
    }
  }
  reverseWalk(block) {
    this.walkValues(block, this.reverseWindows());
  }
  *reverseWindows() {
    let current = this._tail;
    let index = this.count - 1;
    while (current != null) {
      const prev = current.prev;
      yield [prev, current, current.next, index];
      current = prev;
      index--;
    }
  }
};
__name(_DoubleLinkedListImpl, "DoubleLinkedListImpl");
let DoubleLinkedListImpl = _DoubleLinkedListImpl;
const doubleLinkedList = /* @__PURE__ */ __name(() => {
  return new DoubleLinkedListImpl();
}, "doubleLinkedList");
export {
  doubleLinkedList,
  singleLinkedList
};
//# sourceMappingURL=linked-list.mjs.map
