"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var priority_array_exports = {};
__export(priority_array_exports, {
  PriorityArray: () => PriorityArray
});
module.exports = __toCommonJS(priority_array_exports);
var import_binary_index_of = require("./binary-index-of.cjs");
const _PriorityArray = class _PriorityArray {
  constructor(comparator) {
    this.comparator = comparator;
  }
  items = [];
  get [Symbol.toStringTag]() {
    return `PriorityArray+${this.items.length}`;
  }
  get length() {
    return this.items.length;
  }
  add(value) {
    const { exists, before } = (0, import_binary_index_of.binaryIndexOf)(value, this.items, this.comparator);
    if (exists) {
      return;
    }
    if (before === 0) {
      this.items.unshift(value);
    } else if (before === this.items.length) {
      this.items.push(value);
    } else {
      this.items.splice(before, 0, value);
    }
  }
  peek() {
    return this.items[0];
  }
  remove(item) {
    for (let i = this.items.length - 1; i >= 0; i--) {
      const other = this.items[i];
      const comparison = this.comparator(item, other);
      if (comparison === 0) {
        this.items.splice(i, 1);
      } else if (comparison > 0) {
        break;
      }
    }
  }
  take() {
    return this.items.shift();
  }
  toArray() {
    return this.items.slice();
  }
  *values() {
    for (const item of this.items) {
      yield item;
    }
  }
};
__name(_PriorityArray, "PriorityArray");
let PriorityArray = _PriorityArray;
//# sourceMappingURL=priority-array.cjs.map
