var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
import { binaryIndexOf } from "./binary-index-of.mjs";
const _PriorityArray = class _PriorityArray {
  constructor(comparator) {
    this.comparator = comparator;
  }
  items = [];
  get [Symbol.toStringTag]() {
    return `PriorityArray+${this.items.length}`;
  }
  get length() {
    return this.items.length;
  }
  add(value) {
    const { exists, before } = binaryIndexOf(value, this.items, this.comparator);
    if (exists) {
      return;
    }
    if (before === 0) {
      this.items.unshift(value);
    } else if (before === this.items.length) {
      this.items.push(value);
    } else {
      this.items.splice(before, 0, value);
    }
  }
  peek() {
    return this.items[0];
  }
  remove(item) {
    for (let i = this.items.length - 1; i >= 0; i--) {
      const other = this.items[i];
      const comparison = this.comparator(item, other);
      if (comparison === 0) {
        this.items.splice(i, 1);
      } else if (comparison > 0) {
        break;
      }
    }
  }
  take() {
    return this.items.shift();
  }
  toArray() {
    return this.items.slice();
  }
  *values() {
    for (const item of this.items) {
      yield item;
    }
  }
};
__name(_PriorityArray, "PriorityArray");
let PriorityArray = _PriorityArray;
export {
  PriorityArray
};
//# sourceMappingURL=priority-array.mjs.map
