"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var priority_linked_list_exports = {};
__export(priority_linked_list_exports, {
  PriorityLinkedList: () => PriorityLinkedList
});
module.exports = __toCommonJS(priority_linked_list_exports);
var import_linked_list = require("./linked-list.cjs");
const _PriorityLinkedList = class _PriorityLinkedList {
  constructor(comparator) {
    this.comparator = comparator;
  }
  list = (0, import_linked_list.singleLinkedList)();
  get length() {
    return this.list.length;
  }
  add(item) {
    if (this.list.isEmpty) {
      this.list.unshift(item);
    } else {
      const lastIndex = this.list.length - 1;
      this.list.walk((other, index) => {
        const comparison = this.comparator(item, other);
        if (other === item) {
          return { keepWalking: false };
        }
        if (comparison < 0) {
          return { insertBefore: item, keepWalking: false };
        }
        if (index === lastIndex) {
          return { insertAfter: item, keepWalking: false };
        }
        return { keepWalking: true };
      });
    }
  }
  peek() {
    return this.list.head;
  }
  remove(item) {
    this.list.walk((other) => {
      const comparison = this.comparator(item, other);
      if (comparison === 0) {
        return { deleteItem: true, keepWalking: true };
      }
      if (comparison < 0) {
        return { keepWalking: false };
      }
      return { keepWalking: true };
    });
  }
  take() {
    return this.list.shift();
  }
  toArray() {
    return this.list.toArray();
  }
  values() {
    return this.list.values();
  }
};
__name(_PriorityLinkedList, "PriorityLinkedList");
let PriorityLinkedList = _PriorityLinkedList;
//# sourceMappingURL=priority-linked-list.cjs.map
