var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
import { singleLinkedList } from "./linked-list.mjs";
const _PriorityLinkedList = class _PriorityLinkedList {
  constructor(comparator) {
    this.comparator = comparator;
  }
  list = singleLinkedList();
  get length() {
    return this.list.length;
  }
  add(item) {
    if (this.list.isEmpty) {
      this.list.unshift(item);
    } else {
      const lastIndex = this.list.length - 1;
      this.list.walk((other, index) => {
        const comparison = this.comparator(item, other);
        if (other === item) {
          return { keepWalking: false };
        }
        if (comparison < 0) {
          return { insertBefore: item, keepWalking: false };
        }
        if (index === lastIndex) {
          return { insertAfter: item, keepWalking: false };
        }
        return { keepWalking: true };
      });
    }
  }
  peek() {
    return this.list.head;
  }
  remove(item) {
    this.list.walk((other) => {
      const comparison = this.comparator(item, other);
      if (comparison === 0) {
        return { deleteItem: true, keepWalking: true };
      }
      if (comparison < 0) {
        return { keepWalking: false };
      }
      return { keepWalking: true };
    });
  }
  take() {
    return this.list.shift();
  }
  toArray() {
    return this.list.toArray();
  }
  values() {
    return this.list.values();
  }
};
__name(_PriorityLinkedList, "PriorityLinkedList");
let PriorityLinkedList = _PriorityLinkedList;
export {
  PriorityLinkedList
};
//# sourceMappingURL=priority-linked-list.mjs.map
