"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var re_quote_exports = {};
__export(re_quote_exports, {
  DQ: () => DQ,
  SQ: () => SQ,
  reQuote: () => reQuote
});
module.exports = __toCommonJS(re_quote_exports);
const DQ = '"';
const SQ = "'";
const reQuote = /* @__PURE__ */ __name((text, options = {}) => {
  const quotes = options.quotes;
  const auto = options.auto === true || quotes == null;
  let lq;
  let rq;
  if ((quotes == null ? void 0 : quotes.length) === 1) {
    lq = quotes;
    rq = quotes;
  } else if ((quotes == null ? void 0 : quotes.length) === 2) {
    lq = quotes.substring(0, 1);
    rq = quotes.substring(1);
  } else if (quotes === "" || ((quotes == null ? void 0 : quotes.length) ?? 0) > 2) {
    throw new Error(`Too many quote characters: ${JSON.stringify(quotes)}`);
  } else {
    lq = void 0;
    rq = void 0;
  }
  let unquoted = text;
  if (text.length >= 2) {
    const first = text.substring(0, 1);
    const last = text.substring(text.length - 1);
    if (first === lq && last === rq) {
      return text;
    }
    if (first === last && (first === DQ || first === SQ)) {
      const escaped2 = new RegExp(`(?<!\\\\)\\\\${rq}`, "g");
      unquoted = text.substring(1, text.length - 1).replace(escaped2, last);
      if (auto && !unquoted.includes(last)) {
        return text;
      }
    }
  }
  if (lq == null || rq == null) {
    const chars = unquoted.split("");
    const dqCount = chars.filter((c) => c === DQ).length;
    if (dqCount === 0) {
      lq = DQ;
      rq = DQ;
    } else {
      const sqCount = chars.filter((c) => c === SQ).length;
      if (sqCount === 0 || sqCount < dqCount) {
        lq = SQ;
        rq = SQ;
      } else {
        lq = DQ;
        rq = DQ;
      }
    }
  }
  if (lq === DQ && rq === DQ) {
    return JSON.stringify(unquoted);
  }
  const escaped = unquoted.replace(new RegExp(rq, "g"), `\\${rq}`);
  return lq.concat(escaped, rq);
}, "reQuote");
//# sourceMappingURL=re-quote.cjs.map
