export type ReQuoteOptions = {
    /**
     * Use the quotes which would produce the fewest escapes,
     * with a slight preference for double quotes.
     */
    auto?: true;
    quotes?: never;
} | {
    auto?: never;
    /**
     * Use the given quote character(s).  If one character, use
     * it for both start and end.  If two, use them in the order
     * provided.
     */
    quotes?: string;
};
export declare const DQ: "\"";
export declare const SQ: "'";
/**
 * Given a text, either wrap it in quotes which make the most sense
 * for the text, or change the quotes to a different set.
 */
export declare const reQuote: (text: string, options?: ReQuoteOptions) => string;
//# sourceMappingURL=re-quote.d.ts.map